;
;	>>> ISO-Cart by JAC! <<<
;
;	Created for Sillyventure 2011 in Gdansk.
;
;	This file defines the whole 8k cartridge
;
; Type        NTSC  PAL/SECAM
; V-Sync      3     3    scanlines
; V-Blank     37    45   scanlines (upper border)
; Picture     192   228  scanlines
; Overscan    30    36   scanlines (lower border)
; Frame Rate  60    50   Hz
; Frame Time  262   312  scanlines
;
;	@com.wudsn.ide.asm.mainsourcefile=ISO.asm

	.macro m_cart
	
	icl "ISO-Globals.asm"

;===============================================================

	opt h-f+		;Start new banks
	org $7000
	
	.proc bank1
	.print "==============================================================="
	.print "Start of bank 1"
	.print "==============================================================="

;===============================================================

	.def set_hpos_sec_first

	icl "ISO-System.asm"

	.proc cart 

;	icl ":1"

;===============================================================

	icl "ISO-System-Bank1.asm"

;===============================================================

	.endp			;End of cart

	.print "PROC bank1.cart:	", cart, " - ", cart+.len cart-1, " (", .len cart, " bytes)"
	.print "Remaining bank1:	", bank1+$ff8-cart-.len cart , " bytes"

;===============================================================
	org bank1+$ff8		;$xFF8 and $xxFF9 are reserved for bank switching
	.byte $ff,$ff
	.byte $00,$00		;Free

	org bank1+$ffc		;Cartridge vectors
	.word start		;Reset vector
	.word start		;IRQ vector, not really required

	.endp			;End of bank1

;===============================================================

	opt f-			;Start new bank
	org $f000
	opt f+

	.proc bank2
	.print "==============================================================="
	.print "Start of bank 2"
	.print "==============================================================="

;===============================================================

	icl "ISO-System.asm"
	icl "ISO-System-Bank2.asm"

;===============================================================

	.proc cart
;	icl ":2"
	.endp			;End of cart

	.print "PROC bank2.cart:	", cart, " - ", cart+.len cart-1, " (", .len cart, " bytes)"
	.print "Remaining bank2:	", bank2+$ff8-cart-.len cart+cart.free_end-cart.free_start , " bytes"

;===============================================================


	org bank2+$ff8		;$xFF8 and $xxFF9 are reserved for bank switching
	.byte $ff,$ff
	.byte $00,$00		;Free

	org bank2+$ffc		;Cartridge vectors
	.word start		;Reset vector
	.word start		;IRQ vector, used for BRK instruction

	.endp			;End of bank2

	.if .len bank1.system <> .len bank2.system
	.error "Common system block not equal in both banks".
	.endif
	
	.endm