;
;	>>> ISO-Globals by JAC! <<<
;
;	Created for Sillyventure 2011 in Gdansk.
;
;	@com.wudsn.ide.asm.mainsourcefile=ISO.asm

	icl "VCS.asm"

	opt l+

; Zeropage variable declaration
		org $80	;Zeropage variables
cnt		.ds 1		;1 byte
sound_zp	.ds 3		;3 bytes
text_ptr	.ds 2		;2 bytes
text_cnt	.ds 1		;1 byte
text_stage	.ds 1		;1 byte, counting down from $02 to $00
flash_cnt	.ds 1		;1 byte, counting down from $7f..$=0 or up from $80 to $ff
vblank_ptr	.ds 2		;2 bytes
playfield_ptr	.ds 2		;2 bytes
animate_ptr	= volatile_zp	;2 bytes

volatile_zp	.ds 11		;Volatile ZP, maximum is used by logo
stable_zp

logo_zp		= stable_zp
iso_zp		= stable_zp
text_zp		= volatile_zp+4
ribbon_zp	= stable_zp
twister_zp	= stable_zp
chunky_zp	= stable_zp
scroll_zp	= stable_zp

zp_end		= $fa

	.print "ZP iso_zp:	", iso_zp, " - ", zp_end-1, " (", zp_end-iso_zp, " bytes)"


;	Global cartridge locations
.enum mmu	;MMU Bank switching locations
	bank1 = $1ff8	;Any access activates bank 1
	bank2 = $1ff9	;Any access activates bank 2
.ende

	.macro m_set_effect	;Set vblank_ptr and playfield_ptr
	.print "Setting effect addresses: ",:1," ,", :2
	.if >:1 = >:2
	mva #<:1 vblank_ptr
	mva #<:2 playfield_ptr
	lda #>:1
	sta vblank_ptr+1
	sta playfield_ptr+1
	.elseif >:1 = >:2-1
	mva #<:1 vblank_ptr
	mva #<:2 playfield_ptr
	ldx #>:1
	stx vblank_ptr+1
	inx
	stx playfield_ptr+1
	.else
	mwa #:1 vblank_ptr
	mwa #:2 playfield_ptr
	.endif
	.endm


