;
;	>>> ISO-Ribbon by JAC! <<<
;
;	Created for Sillyventure 2011 in Gdansk.


	icl "ISO-Cart-Part1.asm"

;===============================================================

start	cld
	ldx #0
	txa
	tay
init
	dex
	txs
	pha
	bne init		;SP=$FF, X = A = Y = 0
	
	mwa #bank2.cart.effect.init animate_ptr
	jsr call_animate

;===============================================================

	.proc main
frame_loop
	lsr swchb		;Reset pressed?
	bcc start		;Yes, reset
	ldx #$02
	sta wsync
	stx vsync
	sta wsync
	sta wsync
	sta vsync

	.proc vblank
	lda #46
	sta tim64t

	lda flash_cnt
	beq no_dec
	dec flash_cnt
no_dec
	jmp call_vblank
return
sync	lda intim		;Sync with beam again
;	sta colubk
	bne sync
	sta wsync
	sta vblank		;Deactivate VBLANK bit 1
	.endp

:66	sta wsync

;===============================================================

	.proc playfield

	jmp call_playfield
	
return	lda #0
	sta wsync
	sta colubk		;Overscan black
	sta colupf
	sta colup0
	sta colup1
	lda #0
	sta vdelp0
	sta vdelp1
	sta vdelbl
	sta grp0
	sta grp1
	sta enam0
	sta enam1
	sta enabl

	lda #14
	sta wsync
	sta colubk
	lda #0
	sta pf0
	sta pf1
	sta pf2
	sta grp0
	sta grp1
	sta wsync
	sta colubk
	sta pf0
	sta pf1
	sta pf2
	sta grp0
	sta grp1

	.endp			;End of playfield

:6	sta wsync

;===============================================================
	.proc overscan
	lda #2
	sta vblank		;Activate VBLANK bit 1
	lda #41
	sta tim64t		;Overscan time counter

;	jsr sound.player	;Plays sound and returns C=1 if main pattern has changed
;	jsr effect.text.animate

	inc cnt

sync	lda intim		;Sync with beam again
;stop	bmi stop		;Time overrun
	bne sync
	sta wsync
	jmp frame_loop
	
	.endp			;End of overscan
	.endp			;End of main


;===============================================================

	icl "ISO-Cart-Part2.asm"
	
;===============================================================

	.proc effect
	
	icl "ISO-Ribbon.asm"

init	= ribbon.init
	.endp			;End of effect

	.print "PROC effect:	", effect, " - ", effect+.len effect-1, " (", .len effect, " bytes)"

	.align 256

sinus32	dta sin(31,31,256)	;$00...$3e

;===============================================================

	icl "ISO-Cart-Part3.asm"
