;
;	>>> ISO-Ribbon by JAC! <<<
;
;	Created 2011-07-19 for Sillyventure in Gdansk.
;
;	This module requires 0 volatile bytes.
;
;	@com.wudsn.ide.asm.mainsourcefile=ISO.asm

	.proc ribbon


lines		= 157
xpos_offset1	= 4
xpos_offset2	= 143
color2		= $3f

mode	= ribbon_zp
xspeed	= ribbon_zp+1
xpos	= ribbon_zp+2
color0	= ribbon_zp+3
color1	= ribbon_zp+4
pattern	= ribbon_zp+5
now	= ribbon_zp+6
last	= ribbon_zp+7

;===============================================================

	.proc init
	m_set_effect vblank playfield
	mva #0 mode
next	ldx mode
	inc mode
	lda speed,x
	sta xspeed
	lda color,x
	sta color1
	jmp flash_fade.in

speed	.byte   2, -4,  3
color	.byte $60,$50,$9f
	.endp

;===============================================================

	.proc vblank
	clc
	lda xpos
	adc xspeed
	sta xpos

	ldx #lines
	ldy xpos

	clc
	lda sinus32,x		;$00..$3e
	adc sinus32,y		;$00..$3e
	sta last		;$00..$7c (124)

	clc
	adc #xpos_offset1
	sta now

	jsr flash.get_color_and_pattern
	bcs is_flash
	lda color1
	and #$f0
	ora #2
is_flash
	sta color0
	stx pattern

	rts
	.endp			;End of vblank

;===============================================================

	.proc playfield

	ldx #object.p0
	lda now
	jsr object.set_hpos
;	lda other
	lda #xpos_offset2
	sec
	sbc now
	jsr object.set_hpos

	sta wsync
	lda #14
	sta colubk
	lda #1
	sta ctrlpf
	sta refp1
	lda #$30
	sta wsync
	sta pf0
	ldx #0
	stx colubk
	dex
	stx nusiz0		;1 copy, player x4
	stx nusiz1		;1 copy, player x4
	lda pattern
	sta grp0		;Set all bits
	sta grp1
	
	
	.proc first
	ldx color0		;First line is special because of colubk
	ldy xpos

	iny
	iny
	iny
	clc
	lda sinus32+lines
	adc sinus32,y
	sta wsync
	sta hmove
	stx colubk		;First line is special because of colubk
	sta now

	lsr
	eor color1
	sta colup0
	eor #color2
	sta colup1

	sec
	lda last
	sbc now
	asl
	asl
	asl
	asl
	sta hmp0
	eor #$f0
	adc #$10	;C=0 or 1 doesn't matter
	sta hmp1

	lda now
	sta last
	.endp

	ldx #lines-1

	.local loop
	iny
	iny
	iny
	clc
start	lda sinus32,x
	adc sinus32,y
	sta wsync
	sta now
	sta hmove

	lsr
	eor color1
	sta colup0
	eor #color2
	sta colup1

	sec
	lda last
	sbc now
	asl
	asl
	asl
	asl
	sta hmp0
	eor #$f0
	adc #$10	;C=0 or 1 doesn't matter
	sta hmp1

	lda now
	sta last

	dex
	bne loop
	.endl loop

	assert_same_page loop
	rts
	.endp			;End of playfield

;===============================================================

	.endp			;End of ribbon

	.print "PROC ribbon:	", ribbon, " - ", ribbon+.len ribbon-1, " (", .len ribbon, " bytes)"

