;
;	>>> ISO-Sound by JAC! <<<
;
;	Created for Sillyventure 2011 in Gdansk.
;
;	Tune by Jakub Husak.

;
; Type         NTSC  PAL/SECAM
; V-Sync         3     3  scanlines
; V-Blank       37    45  scanlines (upper border)
; Picture      192   228  scanlines
; Overscan      30    36  scanlines (lower border)
; Frame Rate    60    50  Hz
; Frame Time   262   312  scanlines



	icl "ISO-Cart-Part1.asm"

;===============================================================

start	cld
	ldx #0
	txa
	tay
init
	dex
	txs
	pha
	bne init		;SP=$FF, X = A = Y = 0

;===============================================================

	.proc main
frame_loop
	lsr swchb		;Reset pressed?
	bcc start		;Yes, reset
	ldx #$02
	sta wsync
	stx vsync
	sta wsync
	sta wsync
	sta vsync

	.proc vblank_area
	lda #46
	sta tim64t

return
	lda flash_cnt
	beq no_dec
	dec flash_cnt
no_dec

sync	lda intim		;Sync with beam again
	sta colubk
	bne sync
	sta wsync
	sta vblank		;Deactivate VBLANK bit 1
	.endp

:68	sta wsync

;===============================================================

	.proc playfield

	lda #14
	sta wsync
	sta colubk
	lda #0
	sta wsync
	sta colubk

	ldx #157
loop	sta wsync
	dex
	bne loop
	
return	lda flash_cnt
	sta wsync
	sta colubk		;Overscan black
	sta colupf
	sta colup0
	sta colup1
	lda #0
	sta vdelp0
	sta vdelp1
	sta vdelbl
	sta grp0
	sta grp1
	sta enam0
	sta enam1
	sta enabl

	lda #14
	sta wsync
	sta colubk
	lda #0
	sta wsync
	sta colubk
	sta pf0
	sta pf1
	sta pf2
	sta grp0
	sta grp1

	.endp			;End of playfield

:6	sta wsync

;===============================================================
	.proc overscan
	lda #2
	sta vblank		;Activate VBLANK bit 1
	lda #41
	sta tim64t		;Overscan time counter

	jsr sound.player	;Plays sound and returns C=1 if main pattern has changed

	inc cnt

sync	lda intim		;Sync with beam again
;stop	bmi stop		;Time overrun
	bne sync
	sta wsync
	jmp frame_loop
	
	.endp			;End of overscan
	.endp			;End of main

;===============================================================

	icl "ISO-Sound.asm"

;===============================================================

	icl "ISO-Cart-Part2.asm"

;===============================================================

	icl "ISO-Cart-Part3.asm"
	