;
;	>>> ISO-Sound-Tune by Jakub Huask <<<
;
;	This file is in Music Kit 2 format.
;
;	@com.wudsn.ide.asm.mainsourcefile=ISO.asm

delay	= 3	;Number of PAL delay frames

; 000=square  001=bass  010=pitfall  011=noise
; 100=buzz    101=lead  110=saw      111=lowbass
;soundTurnArray
;	byte 9, 0, 8, 9
;	byte 0, 6, 8, 0

; Auto hi hat parameters
hat_start	= 8
hat_volume	= 5
hat_pitch	= 0
hat_sound	= 8

square	= 0<<5
bass	= 1<<5
pitfall	= 2<<5
qbass	= 3<<5
buzz	= 4<<5
lead	= 5<<5
saw	= 6<<5
lowbass	= 7<<5

sq	= 0<<5
bs	= 1<<5
pt	= 2<<5
bq	= 3<<5
bz	= 4<<5
ld	= 5<<5
sw	= 6<<5
bl	= 7<<5

;soundTypeArray
control	.byte $04,$06,$07,$08,$0F,$0C,$01,$03	;Used by get_audfc

	.local pattern
addresses
	.word empty,bass1,solo1,solo2,solo3,int1,solo4,bass2p
	.word solo0,bass1p,solo0a,bassintro,solo0b,endpat1,endpat2

bass1
	.byte bl|30,bl|30, 0, 0, bl|30,bl|30, bl|30, 0
	.byte bl|30, bl|31,bl|29,bl|31, bl|29, 0, bl|30, bl|30
	.byte 0,0,bl|30,bl|30, 0, 0, bl|30,bl|30
	.byte bl|28, bl|29,bl|28,bl|29, bl|28, bl|29, bl|28,0
	.byte $ff,$ff,$fe,$ff
bass2p
	.byte bs|31,bs|31,bs|31,bs|31,bs|31,bs|31,bs|31,bs|31
	.byte bs|31,bs|30,bs|29,bs|28,bs|27,bs|26,bs|25,bs|24
	.byte bs|23,bs|22,bs|21,bs|20,bs|19,bs|18,bs|17,bs|16
	.byte bs|16,bs|16,bs|15,bs|15,bs|14,bs|15,bs|14,bs|13
	.byte $ff,$ff,$ff,$ff
solo1
	.byte sw|30,sw|30, bs|29, bs|29, sw|30,sw|30, sw|30,bs|29
	.byte sw|30, sw|30,sw|30,sw|30, sw|30, 0, sw|30, sw|30
	.byte bs|29,bs|29,sw|30,sw|30, bs|29,bs|29, sw|30,sw|30
	.byte sw|25, sw|25,sw|25,sw|25, sw|25, sw|25, sw|25,0
	.byte $cc,$ff,$fe,$ff
solo2
	.byte sq|28,sq|28, sq|18, sq|18,0,0, sq|28,sq|28
	.byte sq|20, sq|20,0,0, sq|28,sq|28, sq|17, sq|17
	.byte 0,0,sq|28,sq|28,   sq|26,sq|27,sq|26,sq|27
	.byte sq|24, sq|23, 0, 0,, sq|26, sq|27, sq|26,0
	.byte $cc,$ff,$fe,$ff
solo3
	.byte sq|28,sq|28,sq|18,sq|18, 0,0
	.byte sq|20,sq|21,sq|22,sq|22, 0,0
	.byte sq|26,sq|27, sq|28,sq|28,0,0
	.byte 0,0,sw|30,sw|30,sw|30,sw|30
	.byte sw|29,sw|28,sw|29,sw|28
	.byte sw|29,sw|29,sw|29,sw|29

	.byte $cc,$ff,$fe,$f0
int1
	.byte sw|30,sw|30,0,0,sw|30,sw|30,0,0
	.byte pt|28,pt|27,pt|26,pt|25,pt|24,pt|23,pt|22,pt|21
	.byte pt|20,pt|19,pt|18,pt|17,pt|16,pt|15,pt|14,pt|13
	.byte pt|12,pt|10,pt|8,pt|6,pt|4,pt|3,pt|2,pt|1
	.byte $ff,0,0,0
bass1p
	.byte pt|30,bl|30, 0, 0, bl|30,bl|30, bl|30, 0
	.byte bz|4, bl|31,bl|29,bl|31, bl|29, 0, bl|30, bl|30
	.byte pt|14, 0, bl|30,bl|30, 0, 0, bl|30,bl|30
	.byte bz|4, bl|29,bl|28,bl|29, bl|28, bl|29, bl|28,0
	.byte $cc,$ff,$be,$ff
solo4
	.byte sq|13,sq|13, sq|15,sq|19, sq|18,sq|18, sq|19,sq|19
	.byte sq|20,sq|20, sq|23,sq|23
	.byte sq|13,sq|13, sq|15,sq|15, sq|18,sq|18, sq|19,sq|23
	.byte sq|20,sq|20, sq|23,sq|23
	.byte sq|28,sq|28, sq|23, sq|23, sq|20,sq|20, sq|18,sq|18
	.byte $ee,$ee,$ee,$00
solo0
	.byte sq|20,sq|20, sq|19,sq|19,sq|18, sq|18,sq|18,sq|18
	.byte sq|18,sq|18, sq|18,sq|18,sq|18, sq|18,sq|13,sq|18
	.byte sq|13,sq|18, sq|13,sq|18,sq|19, sq|19,sq|20,sq|20
	.byte sq|23,sq|23, sq|28,sq|28, ld|12, ld|12, ld|15,ld|15
	.byte $ce,$00,$2a,$a8
solo0a
	.byte sq|20,sq|20, sq|19,sq|19,sq|18, sq|18,sq|18,sq|18
	.byte sq|18,sq|18, sq|18,sq|18,sq|18, sq|18,sq|13,sq|18
	.byte sq|13,sq|18, sq|20,sq|20,sq|23, sq|23,sq|15,sq|15
	.byte sq|18,sq|18, sq|18,sq|18,sq|18, sq|18,sq|13,sq|18
	.byte $ce,$00,$2a,$a8
solo0b
	.byte sq|20,sq|19, sq|18,sq|18,sq|19, sq|19,sq|20,sq|20
	.byte sq|23,sq|23, sq|28,sq|28, ld|12, ld|12, ld|23, ld|23
	.byte sq|27,sq|28, sq|29
	.byte 0,sw|30,sw|30,sw|30,sw|30
	.byte sw|29,sw|28,sw|29,sw|28
	.byte sw|29,sw|29,sw|29,sw|29
	.byte $c0,$00,$ce,$f0
bassintro
	.byte bs|29,bs|29,bs|29,bs|29,bs|29,bs|29,bs|29,bs|29
	.byte 0,0,0,0,0,0,0,0
	.byte bs|29,bs|29,bs|29,bs|29,bs|29,bs|29,bs|29,bs|29
	.byte 0,0,0,0,0,0,0,0
	.byte $cc,$ff,$cc,$ff
endpat1
	.byte sq|28,sq|28,sq|18,sq|18, 0,0
	.byte sq|20,sq|21,sq|22,sq|22, 0,0
	.byte sq|26,sq|27, sq|28,sq|28,0,0
	.byte 0,0,sw|28,sw|29,sw|28,sw|29
	.byte sw|30,sw|30,sw|30,sw|30
	.byte sw|30,sw|30,sw|30,sw|30
	.byte $cc,$ff,$fe,$f0
endpat2
	.byte sq|18,sq|18,sq|15,sq|15, 0,0
	.byte sq|16,sq|16,sq|18,sq|18, 0,0
	.byte sq|21,sq|21, sq|22,sq|22,0,0
	.byte 0,0,bs|27,bs|28,bs|27,bs|28
	.byte bs|29,bs|29,bs|29,bs|29
	.byte bs|29,bs|29,bs|29,bs|29
	.byte $cc,$ff,$fe,$f0

empty

	.byte $00,$00,$00,$00,$00,$00,$00,$00	;Empty pattern zero, not used in this tune
	.byte $00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00,$00,$00,$00,$00
	.byte $00,$00,$00,$00
	.endl		;End of pattern
