
;	>>> ISO-Twister-Test by JAC! <<<
;
;	Created for Sillyventure 2011 in Gdansk.

text_test = 1	;Disable init calls in script, so only text shows up

;===============================================================

	icl "ISO-Cart-Part1.asm"

;===============================================================

start	cld
	ldx #0
	txa
	tay
init
	dex
	txs
	pha
	bne init		;SP=$FF, X = A = Y = 0
	
	mwa #bank2.cart.effect.init animate_ptr
	jsr call_animate

;===============================================================

	.proc main
frame_loop
	lsr swchb		;Reset pressed?
	bcc start		;Yes, reset
	ldx #$02
	sta wsync
	stx vsync
	sta wsync
	sta wsync
	sta vsync

	.proc vblank
	lda #49
	sta tim64t

	.proc flash
	lda flash_cnt		;Decrement flash counter?
	beq no_flash
	bpl dec_flash		;If the flash value is positive, it's decremented
	cmp #$ff
	beq no_flash 
	inc flash_cnt
	.byte $2c
dec_flash
	dec flash_cnt		;If the flash value is negative, it's incremented 
no_flash
	.endp

	jmp call_vblank
return
sync	lda intim		;Sync with beam again
;	sta colubk
	bne sync
	sta wsync
	sta vblank		;Deactivate VBLANK bit 1
	.endp

:63	sta wsync

;===============================================================

	.proc playfield

	jmp call_playfield
	
return	lda #0
	sta wsync
	sta colubk		;Overscan black
	sta colupf
	sta colup0
	sta colup1
	lda #0
	sta vdelp0
	sta vdelp1
	sta vdelbl
	sta grp0
	sta grp1
	sta enam0
	sta enam1
	sta enabl

	lda #14
	sta wsync
	sta colubk
	lda #0
	sta pf0
	sta pf1
	sta pf2
	sta grp0
	sta grp1
	sta wsync
	sta colubk
	sta pf0
	sta pf1
	sta pf2
	sta grp0
	sta grp1

	.endp			;End of playfield

:6	sta wsync

;===============================================================
	.proc overscan
	lda #2
	sta vblank		;Activate VBLANK bit 1
	lda #41
	sta tim64t		;Overscan time counter

;	jsr sound.player
;	jsr effect.text.animate

	inc cnt

sync	lda intim		;Sync with beam again
;stop	bmi stop		;Time overrun
	bne sync
	sta wsync
	jmp frame_loop
	
	.endp			;End of overscan
	.endp			;End of main

;===============================================================

	icl "ISO-Cart-Part2.asm"

;===============================================================

	.align 256
	.proc effect
	
	icl "ISO-Twister.asm"

init	= twister.init
	.endp			;End of effect

	.print "PROC effect:	", effect, " - ", effect+.len effect-1, " (", .len effect, " bytes)"

;===============================================================

	.align 256
sinus256	dta sin(127,127,256)

; Global color table, 12 PAL colors fading from black to white and back, 256 bytes
coltab	.byte $0,$0,$60,$62,$64,$66,$68,$68,$6a,$6c,$6e,$e,$6e,$6e,$6c,$6a,$68,$66,$64,$62,$62,$60,$0,$40,$42,$44,$44,$46,$48,$4a,$4c,$4e,$e,$e,$4e,$4c,$4a,$48,$46,$46,$44,$42,$40,$0,$20,$20,$22,$24,$26,$28,$2a,$2c,$2c,$2e,$e,$2e,$2c,$2a,$2a,$28,$26,$24,$22,$20,$0,$0,$30,$32,$34,$36,$38,$38,$3a,$3c,$3e,$e,$3e,$3e,$3c,$3a,$38,$36,$34,$32,$32,$30,$0,$50,$52,$54,$54,$56,$58,$5a,$5c,$5e,$e,$e,$5e,$5c,$5a,$58,$56,$56,$54,$52,$50,$0,$70,$70,$72,$74,$76,$78,$7a,$7c,$7c,$7e,$e,$7e,$7c,$7a,$7a,$78,$76,$74,$72,$70,$0,$0,$90,$92,$94,$96,$98,$98,$9a,$9c,$9e,$e,$9e,$9e,$9c,$9a,$98,$96,$94,$92,$92,$90,$0,$b0,$b2,$b4,$b4,$b6,$b8,$ba,$bc,$be,$e,$e,$be,$bc,$ba,$b8,$b6,$b6,$b4,$b2,$b0,$0,$d0,$d0,$d2,$d4,$d6,$d8,$da,$dc,$dc,$de,$e,$de,$dc,$da,$da,$d8,$d6,$d4,$d2,$d0,$0,$0,$c0,$c2,$c4,$c6,$c8,$c8,$ca,$cc,$ce,$e,$ce,$ce,$cc,$ca,$c8,$c6,$c4,$c2,$c2,$c0,$0,$a0,$a2,$a4,$a4,$a6,$a8,$aa,$ac,$ae,$e,$e,$ae,$ac,$aa,$a8,$a6,$a6,$a4,$a2,$a0,$0,$80,$80,$82,$84,$86,$88,$8a,$8c,$8c,$8e,$e,$8e,$8c,$8a,$8a,$88,$86,$84,$82,$80

;===============================================================


	icl "ISO-Cart-Part3.asm"

;===============================================================
